Package: GroupSeq
Title: Group Sequential Design Probabilities - With Graphical User
        Interface
Version: 1.4.3
Authors@R: 
    person("Roman", "Pahl",
    email = "roman.pahl@gmail.com", role = c("aut", "cre"))
Description: Computes probabilities related to group sequential designs for
    normally distributed test statistics. Enables to derive critical
    boundaries, power, drift, and confidence intervals of such designs.
    Supports the alpha spending approach by Lan-DeMets (1994)
    <doi:10.1002/sim.4780131308>.
Imports: tcltk, tcltk2, mvtnorm
Suggests: knitr, tinytest, rmarkdown, ggplot2, gridExtra
VignetteBuilder: knitr
License: GPL-3
URL: https://rpahl.github.io/GroupSeq/
BugReports: https://github.com/rpahl/GroupSeq/issues
NeedsCompilation: no
Author: Roman Pahl [aut, cre]
Maintainer: Roman Pahl <roman.pahl@gmail.com>
Repository: CRAN
RoxygenNote: 7.2.1
Encoding: UTF-8
Packaged: 2024-02-03 13:09:23 UTC; Roman
Date/Publication: 2024-02-03 16:30:02 UTC
Built: R 4.2.3; ; 2024-02-03 17:54:38 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->
<!-- badges: start -->

[![CRAN_Status_Badge](https://www.r-pkg.org/badges/version/GroupSeq)](https://cran.r-project.org/package=GroupSeq)
[![R-CMD-check](https://github.com/rpahl/GroupSeq/actions/workflows/check-standard.yaml/badge.svg)](https://github.com/rpahl/GroupSeq/actions/workflows/check-standard.yaml)
[![dependencies](https://tinyverse.netlify.com/badge/GroupSeq)](https://CRAN.R-project.org/package=GroupSeq)
[![Lifecycle_Badge](https://img.shields.io/badge/lifecycle-stable-green.svg)](https://cran.r-project.org/package=GroupSeq)
[![downloads](https://cranlogs.r-pkg.org/badges/GroupSeq?color=3aa9e8)](https://www.r-pkg.org:443/pkg/GroupSeq)
[![total-downloads](http://cranlogs.r-pkg.org/badges/grand-total/GroupSeq)](https://cran.r-project.org/package=GroupSeq)
[![last-commit](https://img.shields.io/github/last-commit/rpahl/GroupSeq)](https://cran.r-project.org/package=GroupSeq)

<!-- badges: end -->

# GroupSeq <img src="man/figures/logo3D.png" align="right" width="200" height="250"/>

GroupSeq computes probabilities related to group sequential designs for
normally distributed test statistics. It enables to derive critical
boundaries, power, drift, and confidence intervals of such designs,
mostly using the alpha spending approach of [DeMets and
Lan](#ref-pmid7973215) ([1994](#ref-pmid7973215)).

The main motivation for the development of this package was to make this
area of statistics freely available for a broad audience, which is one
of the reasons why all functionality is provided by a graphical user
interface.

### Installation

``` r
# Install release version from CRAN
install.packages("GroupSeq")

# Install development version from GitHub
devtools::install_github("rpahl/GroupSeq")
```

### Usage

Load the library to start the graphical user interface.

``` r
library("GroupSeq")
```

<img src="man/figures/menu-after-load.png" width="30%" />

<br>

To get started see the [General
Introduction](https://rpahl.github.io/GroupSeq/articles/GroupSeq.html)
page.

### Alternative tools

Since the package was written back in 2005, the graphical user interface
may appear a bit outdated. Still, it does it’s job and at least has
stood the test of
time[![^1](https://latex.codecogs.com/png.image?%5Cdpi%7B110%7D&space;%5Cbg_white&space;%5E1 "^1")](#refs).
Luckily in recent years others have started to develop R-based tools
with graphical user interface and similar (and more) statistical
functionality:

-   [gsDesign](https://CRAN.R-project.org/package=gsDesign) with a free
    [shiny web interface](https://gsdesign.shinyapps.io/prod/) including
    tutorials.
-   [rpact](https://CRAN.R-project.org/package=rpact) also with a free
    [shiny web interface](https://rpact.shinyapps.io/public) and lots of
    [vignettes](https://www.rpact.com/vignettes).

### References

<div id="refs" class="references csl-bib-body hanging-indent">

<div id="ref-pmid7973215" class="csl-entry">

DeMets, D. L., and K. K. Lan. 1994. “<span class="nocase">Interim
analysis: the alpha spending function approach</span>.” *Stat Med* 13
(13-14): 1341–52. <https://doi.org/10.1002/sim.4780131308>.

</div>

</div>

------------------------------------------------------------------------

1.  The package author is considering to work on a second version with
    more functionality and a revised user interface in the near future.
    Feel free to request new features
    [here](https://github.com/rpahl/GroupSeq/issues).

## ----knitr-setup, include = FALSE-----------------------------------------------------------------
library(knitr)
knitr::opts_chunk$set(
  comment = "#",
  prompt = F,
  tidy = FALSE,
  cache = FALSE,
  collapse = T,
  echo = FALSE,
  dpi = 300,
  fig.width = 5, fig.height = 5
)

old <- options(width = 100L, digits = 10)

## ----out.width = "35%", echo = FALSE--------------------------------------------------------------
include_graphics("figures/task3-example-manual-bounds.png")

## ----out.width = "50%"----------------------------------------------------------------------------
include_graphics("figures/task3-example-manual-bounds-results.png")

## ----out.width = "35%"----------------------------------------------------------------------------
include_graphics("figures/task3-example-manual-bounds-zero-drift.png")

## ----out.width = "50%"----------------------------------------------------------------------------
include_graphics("figures/task3-example-manual-bounds-zero-drift-results.png")

## ----out.width = c("40%", "55%"), echo = FALSE, fig.show = "hold"---------------------------------
include_graphics("figures/task3-example-manual-bounds-zero-drift-adjusted.png")
include_graphics("figures/task3-example-manual-bounds-zero-drift-adjusted-results.png")

## ----out.width = c("40%", "55%"), echo = FALSE, fig.show = "hold"---------------------------------
include_graphics("figures/task3-manual-Pocock.png")
include_graphics("figures/task3-manual-Pocock-results.png")

## ----out.width = c("40%", "55%"), echo = FALSE, fig.show = "hold"---------------------------------
include_graphics("figures/task3-exact-Pocock.png")
include_graphics("figures/task3-exact-Pocock-results.png")

## ----out.width = c("40%", "55%"), echo = FALSE, fig.show = "hold"---------------------------------
include_graphics("figures/task3-exact-Pocock-drift2.png")
include_graphics("figures/task3-exact-Pocock-drift2-results.png")

## ----include = FALSE----------------------------------------------------------
options(old)

## ----knitr-setup, include = FALSE-----------------------------------------------------------------
library(knitr)
library("ggplot2")

knitr::opts_chunk$set(
  comment = "#",
  prompt = F,
  tidy = FALSE,
  cache = FALSE,
  collapse = T,
  echo = FALSE,
  dpi = 300,
  fig.width = 5, fig.height = 5
)

okabe_palette <- c('orange' = "#E69F00",
                   'sky blue' = "#56B4E9",
                   'bluish green' = "#009E73",
                   'yellow' = "#F0E442",
                   'blue' = "#0072B2",
                   'vermillion' = "#D55E00",
                   'reddish purple' = "#CC79A7")

old <- options(width = 100L, digits = 10)

## -------------------------------------------------------------------------------------------------
fill_colors = c(X1 = okabe_palette[["bluish green"]],
                X2 = okabe_palette[["vermillion"]],
                "X1+X2" = "#6B7E3A")

data  = data.frame(x = c(1:10, 1:10, 1:20),
                   y = c(rep(2, 10), rep(1.5, 10), rep(1.5, 20)),
                   Sample = c(rep("X1", 10), rep("X2", 10), rep("X1+X2", 20))
)

## ----out.width = "35%", message = FALSE, fig.height = 1, fig.width = 2.5, fig.align = "center", fig.cap = "Schematic view of a study sample - each circle represents some measurement."----
dat = data[1:10, ]
ggplot(dat, aes(x = x, y = y)) +
    geom_point(size = 10, shape = 21, aes(fill = Sample)) +
    scale_fill_manual(values = fill_colors[1]) +
    lims(x = c(0.5, 10.5), y = c(2, 2)) +
    theme_void() +
    theme(legend.position = "bottom")


## ----echo = FALSE, out.width = "65%", fig.cap = fig.cap, fig.height=3-----------------------------
fig.cap = "Standard Normal Density with critial bounds marking 5% significance level."

blue = okabe_palette[["sky blue"]]
yellow = okabe_palette[["yellow"]]


crit = qnorm(1 - 0.025)
probLabel = paste0(pnorm(-crit)*100, "%")
x = seq(-3, 3, by = 0.01)

normalDensPlot =
    ggplot(data.frame(x = x), aes(x = x)) +
    stat_function(fun = dnorm, geom = "area", fill = blue, xlim = c(-4, -crit)) +
    stat_function(fun = dnorm, geom = "area", fill = yellow, xlim = c(-crit, crit)) +
    stat_function(fun = dnorm, geom = "area", fill = blue, xlim = c(crit, 4)) +
    stat_function(fun = dnorm, color = okabe_palette[["bluish green"]], size = 1.5) +
    geom_segment(x = 2.2, xend = 2.7, y = 0.02, yend = 0.07) +
    geom_segment(x = -2.2, xend = -2.7, y = 0.02, yend = 0.07) +
    annotate("text", label = probLabel, x = 2.9, y = 0.09, size = 3.5) +
    annotate("text", label = probLabel, x = -2.9, y = 0.09, size = 3.5) +
    lims(x = range(x)) +
    labs(x = expression(x[1]),
         y = expression(f(x[1]))) +
    theme_minimal() +
    theme(panel.grid.major = element_blank(),
          panel.grid.minor = element_blank(),
          axis.ticks.x = element_line())

normalDensPlot

## ----echo = TRUE----------------------------------------------------------------------------------
qnorm(0.025)

## ----out.width = "35%", message = FALSE, fig.height = 1.3, fig.width = 2.5, fig.align = "center"----
dat = data[1:20, ]
ggplot(dat, aes(x = x, y = y)) +
    geom_point(size = 10, shape = 21, aes(fill = Sample)) +
    scale_fill_manual(values = fill_colors[1:2]) +
    lims(x = c(0.5, 10.5), y = c(1.2, 2.2)) +
    theme_void() +
    theme(legend.position = "bottom")


## ----fig.width = 8, fig.height = 3, out.width = "85%"---------------------------------------------
normalDensPlotX2 = normalDensPlot +
    labs(x = expression(x[2]), y = expression(f(x[2]))) +
    stat_function(fun = dnorm, color = okabe_palette[["vermillion"]], size = 1.5)
gridExtra::grid.arrange(normalDensPlot, normalDensPlotX2, nrow = 1)

## ----echo = TRUE----------------------------------------------------------------------------------
qnorm(0.025/2)

## ----echo = FALSE, out.width = "65%", fig.cap = fig.cap, fig.height=3-----------------------------
fig.cap = "Standard Normal Density with critial bounds marking 5% significance level."

blue = okabe_palette[["sky blue"]]
yellow = okabe_palette[["yellow"]]

crit = qnorm(1 - 0.025/2)
probLabel = paste0(pnorm(-crit)*100, "%")
x = seq(-3, 3, by = 0.01)

normalDensPlotAdj =
    ggplot(data.frame(x = x), aes(x = x)) +
    stat_function(fun = dnorm, geom = "area", fill = blue, xlim = c(-4, -crit)) +
    stat_function(fun = dnorm, geom = "area", fill = yellow, xlim = c(-crit, crit)) +
    stat_function(fun = dnorm, geom = "area", fill = blue, xlim = c(crit, 4)) +
    stat_function(fun = dnorm, color = okabe_palette[["bluish green"]], size = 1.2) +
    geom_segment(x = 2.2+.2, xend = 2.7+.2, y = 0.02, yend = 0.07) +
    geom_segment(x = -2.2-.2, xend = -2.7-.2, y = 0.02, yend = 0.07) +
    annotate("text", label = probLabel, x = 2.9, y = 0.09, size = 3.5) +
    annotate("text", label = probLabel, x = -2.9, y = 0.09, size = 3.5) +
    lims(x = range(x)) +
    labs(x = expression(x[1]),
         y = expression(f(x[1]))) +
    theme_minimal() +
    theme(panel.grid.major = element_blank(),
          panel.grid.minor = element_blank(),
          axis.ticks.x = element_line())

## ----fig.width = 8, fig.height = 3, out.width = "85%"---------------------------------------------
normalDensPlotX2Adj = normalDensPlotAdj +
    labs(x = expression(x[2]), y = expression(f(x[2]))) +
    stat_function(fun = dnorm, color = okabe_palette[["vermillion"]], size = 1.5)
gridExtra::grid.arrange(normalDensPlotAdj, normalDensPlotX2Adj, nrow = 1)

## -------------------------------------------------------------------------------------------------
alpha = 0.05
alpha.Bonf = alpha / 2
alpha.Sidak = 1 - (1-alpha)^(1/2)

crit.Bonf = -rep(qnorm(alpha.Bonf / 2), 2)
crit.Sidak = -rep(qnorm(alpha.Sidak / 2), 2)

## ----prepare-2D-normal-density-plot, echo = FALSE, include = FALSE--------------------------------
mu = 0
Mean = c(mu, mu)
covariance = 0
Sigma0 = matrix(c(1, rep(covariance, 2), 1), 2)


width = 6.6
binwidth = 0.2
x1 = x2 = seq(from = mu - width/2, to = mu + width/2, by = binwidth)
grid = expand.grid(x1, x2)

z = mvtnorm::dmvnorm(grid, mean = Mean, sigma = Sigma0)
zmat = matrix(z, ncol = length(x1))

grid.col = expand.grid(x1[-1] - binwidth/2, x2[-1] - binwidth/2)
gc1 = grid.col[, 1]
gc2 = grid.col[, 2]

crit = crit.Sidak
get_color = Vectorize(function(x1, x2) {
    if (x1 < -crit[1] || x1 > crit[1] || x2 < -crit[2] || x2 > crit[2])
        blue else yellow
})

plot_normal_dens_2d = function(zmat, ...) {
    persp(x1, x2, zmat,
          expand = 0.5,
          lphi = 0,
          xlab = "x1",
          ylab = "x2\n",
          zlab = "f(x1, x2)",
          shade = 0.2,
          ticktype = "detailed",
          ...)
}

## ----out.width = "55%"----------------------------------------------------------------------------
op = par(mar = c(0, 2, 0, 0))
plot_normal_dens_2d(zmat, phi = 45, col = get_color(gc1, gc2))
par(op)

## ----include = FALSE------------------------------------------------------------------------------
crit.Bonf = -rep(qnorm(alpha.Bonf / 2), 2)
crit.Sidak = -rep(qnorm(alpha.Sidak / 2), 2)

crit = crit.Bonf
crit = crit.Sidak

calc2Dprob = function(crit, sigma) {
    calc_prob = function(lower, upper) {
        as.numeric(mvtnorm::pmvnorm(lower = lower, upper = upper, sigma = sigma))
    }

    left_stripe = calc_prob(lower = c(-Inf, -Inf), upper = c(-crit[1], Inf))
    lower_rectangle = calc_prob(lower = c(-crit[1], -Inf), upper = c(crit[1], -crit[2]))
    2 * left_stripe + 2 * lower_rectangle # return two-sided prob
}

p.edge = as.numeric(mvtnorm::pmvnorm(lower = c(-Inf, -Inf),
                                     upper = c(-crit[1], -crit[2]),
                                     sigma = Sigma0))


p2D.Bonf = calc2Dprob(crit.Bonf, sigma = Sigma0)
p2D.Sidak = calc2Dprob(crit.Sidak, sigma = Sigma0)

## ----out.width = "55%"----------------------------------------------------------------------------
orange = okabe_palette[["orange"]]
crit = crit.Sidak
get_color_edges = Vectorize(function(x1, x2) {
    # Make edges grey
    if (x1 < -crit[1] && x2 < -crit[2] ||
        x1 < -crit[1] && x2 >  crit[2] ||
        x1 >  crit[1] && x2 < -crit[2] ||
        x1 >  crit[1] && x2 >  crit[2])
        return("grey")

    if (x1 < -crit[1] || x1 > crit[1] || x2 < -crit[2] || x2 > crit[2])
        blue else yellow
})

op = par(mar = c(0, 2, 0, 0))
plot_normal_dens_2d(zmat, phi = 45, col = get_color_edges(gc1, gc2))
par(op)

## ----out.width = "35%", message = FALSE, fig.height = 1.3, fig.width = 2.5, fig.align = "center"----
dat = data[1:20, ]
dat[11:20, "x"] = 11:20
dat = rbind(data.frame(x = 1:10, y = 1.5, Sample = "X1"), dat)
ggplot(dat, aes(x = x, y = y)) +
    geom_point(size = 10, shape = 21, aes(fill = Sample)) +
    scale_fill_manual(values = fill_colors[1:2]) +
    lims(x = c(0.5, 20.5), y = c(1.2, 2.2)) +
    theme_void() +
    theme(legend.position = "bottom")


## ----out.width = "35%", message = FALSE, fig.height = 1.3, fig.width = 2.5, fig.align = "center", fig.cap = "Schematic view of group sequential two-stage study."----
dat = data[c(1:10, 21:40), ]

ggplot(dat, aes(x = x, y = y)) +
    geom_point(size = 10, shape = 21, aes(fill = Sample)) +
    scale_fill_manual(values = fill_colors[c(1, 3)]) +
    lims(x = c(0.5, 20.5), y = c(1.2, 2.2)) +
    theme_void() +
    theme(legend.position = "bottom")


## ----fig.width = 8, fig.height = 3, out.width = "85%", fig.cap = "Normal densities for stage 1 and 2 with Bonferroni bounds."----
normalDensPlotX2Adj = normalDensPlotAdj +
    labs(x = expression(x[2]), y = expression(f(x[2]))) +
    stat_function(fun = dnorm, color = fill_colors[3], size = 1.5)
gridExtra::grid.arrange(normalDensPlotAdj, normalDensPlotX2Adj, nrow = 1)

## -------------------------------------------------------------------------------------------------
mu = 0
Mean = c(mu, mu)
covariance = sqrt(0.5)
Sigma = matrix(c(1, rep(covariance, 2), 1), 2)

z = mvtnorm::dmvnorm(grid, mean = Mean, sigma = Sigma)
zmat = matrix(z, ncol = length(x1))

## ----fig.show="hold", out.width = "30%", fig.cap = "Bivariate normal density of two-stage design viewed from different angles."----
op = par(mar = rep(.1, 4))
plot_normal_dens_2d(zmat, phi = 40, col = get_color(gc1, gc2), box = FALSE)
plot_normal_dens_2d(zmat, phi = 65, col = get_color(gc1, gc2), box = FALSE)
plot_normal_dens_2d(zmat, phi = 90, col = get_color(gc1, gc2), box = FALSE)
par(op)

## -------------------------------------------------------------------------------------------------
p2D.Bonf = calc2Dprob(crit.Bonf, sigma = Sigma)

## ----out.width = "40%", echo = FALSE--------------------------------------------------------------
include_graphics("figures/two-stage-Pocock-bounds.png")

## ----out.width = "70%", echo = FALSE--------------------------------------------------------------
include_graphics("figures/two-stage-Pocock-bounds-result.png")

## -------------------------------------------------------------------------------------------------
crit.Pocock = rep(2.1783, 2)
p2D.Pocock = calc2Dprob(crit.Pocock, sigma = Sigma)

## ----echo = FALSE, out.width = "50%", fig.cap = "Group sequential 2-stage Pocock design with one interim look at half of the total samples."----
n = 100
tt = c(.5, 1)
crit = crit.Pocock
x = seq(0.2, 1.0, length = n)

upperLine = data.frame(x = x, y = crit[1])
lowerLine = data.frame(x = x, y = -crit[1])

upperArea = data.frame(x = x, ymin = upperLine$y, ymax = 3, y = 3)
innerArea = data.frame(x = x, ymin = lowerLine$y, ymax = upperLine$y, y = 0)
lowerArea = data.frame(x = x, ymin = -3, ymax = lowerLine$y, y = -3)

p = ggplot(mapping = aes(x = x, y = y)) +

    geom_ribbon(data = upperArea, aes(x = x, ymin = ymin, ymax = ymax, y = y), fill = blue) +
    geom_ribbon(data = innerArea, aes(x = x, ymin = ymin, ymax = ymax, y = y), fill = yellow) +
    geom_ribbon(data = lowerArea, aes(x = x, ymin = ymin, ymax = ymax, y = y), fill = blue) +

    geom_line(data = upperLine) +
    geom_line(data = lowerLine) +

    geom_point(data = data.frame(x = tt, y =  crit), size = 5, shape = 21, fill = fill_colors[c(1, 3)]) +
    geom_point(data = data.frame(x = tt, y = -crit), size = 5, shape = 21, fill = fill_colors[c(1, 3)]) +

    theme_minimal() +
    labs(x = "Information Rate", y = "Critical Value") +
    lims(y = c(-3, 3)) +
    theme(panel.grid.major = element_blank(),
          panel.grid.minor = element_blank(),
          axis.ticks.x = element_line())

p

## ----echo = FALSE, out.width = "50%", fig.cap = "Group sequential 2-stage O'Brien-Fleming design with one interim look at 0.5."----

asOBF <- function(t, alpha = 0.05, side = 2) {
  2 * (1 - stats::pnorm((stats::qnorm(1 - (alpha / side)/2)) / sqrt(t)))
}

n = 100
tt = c(.5, 1)

crit.OBF = -qnorm(asOBF(tt))
crit = crit.OBF
x = seq(0.2, 1.0, length = n)

upperLine = data.frame(x = x, y = -qnorm(asOBF(x)))
lowerLine = data.frame(x = x, y = qnorm(asOBF(x)))

upperArea = data.frame(x = x, ymin = upperLine$y, ymax = 6, y = 3)
innerArea = data.frame(x = x, ymin = lowerLine$y, ymax = upperLine$y, y = 0)
lowerArea = data.frame(x = x, ymin = -6, ymax = lowerLine$y, y = -3)

p = ggplot(mapping = aes(x = x, y = y)) +

    geom_ribbon(data = upperArea, aes(x = x, ymin = ymin, ymax = ymax, y = y), fill = blue) +
    geom_ribbon(data = innerArea, aes(x = x, ymin = ymin, ymax = ymax, y = y), fill = yellow) +
    geom_ribbon(data = lowerArea, aes(x = x, ymin = ymin, ymax = ymax, y = y), fill = blue) +

    geom_line(data = upperLine) +
    geom_line(data = lowerLine) +

    geom_point(data = data.frame(x = tt, y =  crit), size = 5, shape = 21, fill = fill_colors[c(1, 3)]) +
    geom_point(data = data.frame(x = tt, y = -crit), size = 5, shape = 21, fill = fill_colors[c(1, 3)]) +

    theme_minimal() +
    labs(x = "Information Rate", y = "Critical Value") +
    lims(y = c(-6, 6)) +
    theme(panel.grid.major = element_blank(),
          panel.grid.minor = element_blank(),
          axis.ticks.x = element_line())

p


## ----out.width = "70%", echo = FALSE--------------------------------------------------------------
include_graphics("figures/two-stage-OBF-bounds-result.png")

## ----fig.show="hold", out.width = "45%", fig.cap = "Bivariate normal density with critical bounds of Pocock (left) and O'Brien-Fleming design (right) both with interim analysis after 50% of the sample."----
op = par(mar = rep(1.5, 4))
crit = crit.Pocock
plot_normal_dens_2d(zmat, phi = 80, col = get_color(gc1, gc2))
crit = crit.OBF
plot_normal_dens_2d(zmat, phi = 80, col = get_color(gc1, gc2))
par(op)

## ----fig.show="hold", out.width = "30%", fig.cap = "Bivariate normal density of two-stage O'Brien-Fleming design with first stage after 50% (left), 70% (middle) and 90% (right) of all samples."----

crit = crit.OBF
mu = 0
Mean = c(mu, mu)

Sigma = matrix(c(1, rep(sqrt(0.5), 2), 1), 2)
z = mvtnorm::dmvnorm(grid, mean = Mean, sigma = Sigma)
zmat0.5 = matrix(z, ncol = length(x1))

Sigma = matrix(c(1, rep(sqrt(0.7), 2), 1), 2)
z = mvtnorm::dmvnorm(grid, mean = Mean, sigma = Sigma)
zmat0.7 = matrix(z, ncol = length(x1))

Sigma = matrix(c(1, rep(sqrt(0.9), 2), 1), 2)
z = mvtnorm::dmvnorm(grid, mean = Mean, sigma = Sigma)
zmat0.9 = matrix(z, ncol = length(x1))


op = par(mar = rep(.1, 4))
plot_normal_dens_2d(zmat0.5, phi = 90, col = get_color(gc1, gc2), box = FALSE)
plot_normal_dens_2d(zmat0.7, phi = 90, col = get_color(gc1, gc2), box = FALSE)
plot_normal_dens_2d(zmat0.9, phi = 90, col = get_color(gc1, gc2), box = FALSE)
par(op)

## ----include = FALSE----------------------------------------------------------
options(old)

exit_file("Internal functions of legacy code")

# calculateEqualBounds
n <- 1
t2 <- (1:n)/n
bb <- rep(2, n)
res <- calculateEqualBounds(0.05, bb, n, t2)
expect_equal(res, qnorm(1 - 0.05))

n <- 4
t2 <- (1:n)/n
bb <- rep(2, n)

res <- calculateEqualBounds(0.05, bb, n, t2)
expect_equal(res, rep(2.06739, n), tol=1e-5)

res <- calculateEqualBounds(0.05/2, bb, n, t2)
expect_equal(res, rep(2.361263, n), tol=1e-5)

# computeAlphaLevel
alpha <- 0.05
n <- 1
t <- (1:n)/n
t2 <- (1:n)/n
lo <- -8
drift <- 0
nMax <- 25

up <- qnorm(1-alpha)
res <- computeAlphaLevel(n, t, t2, lo, up, drift, nMax)

expect_equal(res$probAndStop, alpha)
expect_equal(res$probAndExceedingUpper, alpha)
expect_equal(res$probAndExceedingLower, 0, tol=1e-10)
expect_equal(res$expectedStoppingTime, 0)
expect_equal(res$totalTypeOneError, alpha)

n <- 4
t <- 0
t2 <- (1:n)/n
lo <- rep(-8, n)
up <- rep(2.06739, n)
res <- computeAlphaLevel(n, t, t2, lo, up, drift, nMax)
expect_equal(res$probAndStop, c(0.0193487, 1, 1, 1), tol = 1e-6)
expect_equal(res$probAndExceedingUpper, tol = 1e-6,
             c(0.019348701, 0.013193548, 0.009750731, 0.007707020))
expect_equal(res$probAndExceedingLower, rep(0, n), tol=1e-10)
expect_equal(res$expectedStoppingTime, 0)
expect_equal(res$totalTypeOneError, alpha, tol=1e-6)

t <- (1:n)/n
up <- c(4.332634, 2.963129, 2.35902, 2.014057)
lo <- -up
drift <- 0.5
res <- computeAlphaLevel(n, t, t2, lo, up, drift, nMax)
expect_equal(res$probAndStop, c(2.455984e-05, 1, 1, 1), tol = 1e-6)
expect_equal(res$probAndExceedingUpper, tol = 1e-6,
             c(2.226406e-05, 4.516532e-03, 2.356205e-02, 4.300024e-02))
expect_equal(res$probAndExceedingLower, tol = 1e-6,
             c(2.295776e-06, 4.541068e-04, 2.341142e-03, 4.281890e-03))
expect_equal(res$totalTypeOneError, 0.07818052, tol=1e-7)

# computeBounds
n <- 3
drift <- 0
alpha <- 0.05
phi <- 1
t <- (1:n)/n
t2 <- t
res <- computeBounds(n, drift, alpha, 1, t, t2, 1, 1, 8)
expect_equal(res$lowerBounds, rep(-8, n))
expect_equal(res$upperBounds, c(3.200102, 2.140797, 1.694775), tol=1e-6)
expect_equal(res$exitProbabilities, c(0.0006868949, 0.0163746665, 0.05), tol=1e-6)
diffs <- c(res$exitProbabilities[1], diff(res$exitProbabilities))
expect_equal(res$differencesExitProbabilities, diffs)

# Interface

exit_file("Internal gui functions - only tested interactively")

win <- start_gui(legacy = TRUE)
expect_true(tcltk::is.tkwin(pkg.env$taskWindow))
onQuit()

e <- init_env()
win <- gui(e$at2("root"))
expect_true(tcltk::is.tkwin(win))
onQuit()
expect_true(e$is_empty())
rm(e)

if (F) {
    test_gui <- function() {
        devtools::load_all()
        root <- tcltk::tktoplevel()
        win <- gui(root)
    }
    run_tests <- function() {
        devtools::load_all()
        tinytest::run_test_dir(system.file("tinytest", package="GroupSeq"))
    }
    run_tests()

    test_gui()

    start_gui()

}

exit_file("Internal functions not yet exported")

# seqProb
# Invalid calls
expect_error(seqProb(), info='argument "up" is missing, with no default')
expect_error(seqProb(up=1:3, mean=1:3), info="length of mean must be 1")
expect_error(seqProb(lo=1, up=-1), info="up >= lo is not TRUE")
expect_error(seqProb(lo=1:2, up=c(3:5)), info="incompatible bounds")
expect_error(seqProb(0, sd=-1), info="sd must be > 0")
expect_error(seqProb(up=1:3, tau=1:2/2), info="incompatible up and tau")

# 1 dimensional
expect_equal(seqProb(0), pnorm(0))
expect_equal(seqProb(0, exitLast=TRUE), pnorm(0))
set.seed(123)
z <- rnorm(1)
expect_equal(seqProb(z), pnorm(z))
expect_equal(seqProb(z, exitLast=TRUE), 1-seqProb(z))
p <- .95
expect_equal(seqProb(qnorm(p)), p)
expect_equal(seqProb(1, mean=1), pnorm(1, mean=1))
expect_equal(seqProb(2, mean=1, sd=2), pnorm(2, mean=1/2, sd=1))
expect_equal(seqProb(2, mean=1, sd=2, hasZbounds=FALSE),
             pnorm(2, mean=1, sd=2))

expect_equal(seqProb(-Inf), 0)
expect_equal(seqProb(-Inf, exitLast=TRUE), 1)
expect_equal(seqProb(Inf), 1)
expect_equal(seqProb(Inf, exitLast=TRUE), 0)

# Multivariate
expect_equal(seqProb(c(Inf, 0)), seqProb(0))
expect_equal(seqProb(c(-Inf, 0)), 0)
set.seed(12345)
expect_equal(seqProb(c(Inf, Inf, 0),
                     alg=mvtnorm::GenzBretz()),  # standard alg would crash
             seqProb(0))
p1 <- seqProb(c(2, 2, 2), mean=0)
p2 <- seqProb(c(2, 2, 2), mean=1)
p3 <- seqProb(c(1, 1, 1), mean=1)
p4 <- seqProb(c(1, 1, 0), mean=1)
expect_true(p1 > p2)
expect_true(p2 > p3)
expect_true(p3 > p4)

# Make sure it can handle singular covariance matrices
up <- rep(2, 3)
singularCovVarCausingSD <- rep(1, 3)
expect_true(inherits(seqProb(up, mean=0, sd=singularCovVarCausingSD), "numeric"))

# Vary tau
##########
crit <- c(2, 2)
tau <- (1:2)/2

# If mean (or drift) is 0, scaling tau should have no effect on probability
p0 <- seqProb(crit, mean=0, tau=tau, exitLast=TRUE)
expect_equal(p0, seqProb(crit, mean=0, tau=tau*2, exitLast=TRUE))
expect_equal(p0, seqProb(crit, mean=0, tau=tau/3, exitLast=TRUE))

# In contrast, for non-zero mean, a scale-effect is expected, which
# basically can be interpreted in terms of in-/decreasing power by
# in-/decreasing the sample size
p1 <- seqProb(crit, mean=1, tau=tau, exitLast=TRUE)
expect_true(p1 < seqProb(crit, mean=1, tau=tau*2, exitLast=TRUE)) # doubled sample size
expect_true(p1 > seqProb(crit, mean=1, tau=tau/3, exitLast=TRUE)) # 1/3 of sample size

# For non non-linear scaling, an effect is expected as well
expect_false(p0 == seqProb(crit, mean=0, tau=tau*c(1, 2), exitLast=TRUE))

# Compare seqProb with reference software by Lan-DeMets
# Reference values were calculated using Lan-DeMets software - see:
# https://www.biostat.wisc.edu/sites/default/files/lan-demets/WinLD.zip
# All results were obtained using Compute -> Probability, One-Sided and
# manually entered test boundaries (i.e. no alpha spending function).

# The calculated reference probabilites (lanDeMets) are found in the
# rightmost column ('Cum exit pr') of the result table of the software.
# The following function will perform the corresponding calculations based
# on seqProb:
calculate_Cum_exit_pr <- function(Time, upperBound,
                                  lowerBound=rep(-Inf, length(upperBound)), ...) {
    p <- numeric(length(Time))
    for (i in seq_along(Time)) {
        p[i] <- seqProb(upperBound[1:i], tau=Time[1:i], lo=lowerBound[1:i],
                        exitLast=TRUE, ...)
    }
    cumsum(p)
}

# Do some 4-stage calculations
times <- c(0.25, 0.50, 0.75, 1.00)
bounds <- c(4, 3, 2, 1)
cumP <- calculate_Cum_exit_pr(times, bounds)
lanDeMets <- c(0.00003, 0.00137, 0.02294, 0.15934)
expect_equal(cumP, lanDeMets, tol = 1e-4)

# Use drift = 2
drift <- 2
cumP <- calculate_Cum_exit_pr(times, bounds, mean=drift)
lanDeMets <- c(0.00135, 0.05660, 0.39529, 0.84180)
expect_equal(cumP, lanDeMets, tol = 1e-4)

# Non-standard information times (instead of equally spaced)
times <- c(.1, .2, .4, .7)
cumP <- calculate_Cum_exit_pr(times, bounds)
lanDeMets <- c(0.00003, 0.00137, 0.02321, 0.16175)
expect_equal(cumP, lanDeMets, tol = 1e-4)

# Again with drift
drift <- 1.5
cumP <- calculate_Cum_exit_pr(times, bounds, mean=drift)
lanDeMets <- c(0.00021, 0.00999, 0.14786, 0.60399)
expect_equal(cumP, lanDeMets, tol = 1e-4)

# Trivial 1-stage 'sequential' designs"
# One stage designs represent the special (actually non-sequential) case
alpha <- 0.05
crit <- qnorm(1 - alpha)

# Invalid calls
expect_error(seqDesign(), info='crit is missing')
expect_error(seqDesign(as.logical(crit)), info='crit must be numeric')
expect_error(seqDesign(crit, tau=1:2/2), info="incompatible crit and tau")
expect_error(seqDesign(crit, sd=1/sqrt(1:2)), info="incompatible crit and sd")
expect_error(seqDesign(1:2, tau=2:1/2), info="tau not increasing")
expect_error(seqDesign(crit, futStop=crit+0.1),
             info="Futility stop must not exceed critical limit")

result <- seqDesign(crit)
expect_equal(result$p$exit, alpha)
expect_equal(sum(unlist(result$p)), 1)

# Set mean equal to critical limit, which means
# z = x - mean = crit - crit = 0, which gives power of 0.5
expect_equal(seqDesign(crit, mu=crit)$p$exit, 0.5)

# If mean < critical limit, power falls below 0.5 ...
pow <- seqDesign(crit, mu=crit/2)$p$exit
expect_true(pow < 0.5)
# ... but increases if std dev decreases under H1
expect_true(seqDesign(crit, mu=crit/2, sd=1/sqrt(2))$p$exit > pow)

# If mean > critical limit, power rises above 0.5 ...
pow2 <- seqDesign(crit, mu=crit*2)$p$exit
expect_true(pow2 > 0.5)
# ... but decreases if std dev increases under H1
expect_true(seqDesign(crit, mu=crit*2, sd=2)$p$exit < pow2)

# Multi-stage sequential designs consistency checks
isIncreasing <- function(x) !is.unsorted(x)
isDecreasing <- function(x) !is.unsorted(rev(x))

# Design under H0 (i.e. mu == 0)
crit <- rep(2, 4)
d0 <- seqDesign(crit)
expect_equal(length(d0$p$exit), length(crit))
expect_true(isDecreasing(d0$p$exit))
expect_true(isDecreasing(d0$undecided))
# Verify that alpha under H0 does not depend on n
expect_equal(d0$p$exit, seqDesign(crit, n=100)$p$exit)

# Design under H1
d1 <- seqDesign(crit, mu=1)
expect_true(all(d1$p$undecided < d0$p$undecided))
expect_true(isDecreasing(d1$p$undecided))

expect_equal(d1, seqDesign(crit, mu=1, n=1))
# Under H1, the overall power should increase with increasing n
expect_true(sum(seqDesign(crit, mu=1, n=5)$p$exit) > sum(d1$p$exit))

dfs0 <- seqDesign(crit, mu=0, futStop=rep(0, 4))
expect_true(isIncreasing(dfs0$cumFutStop))
dfs1 <- seqDesign(crit, mu=1, futStop=rep(0, 4))
expect_true(isIncreasing(dfs1$cumFutStop))

# Due to added futility stops, the following conditions should hold:
expect_true(all(dfs0$p$exit[-1] < d0$p$exit[-1]))
expect_true(all(dfs1$p$exit[-1] < d1$p$exit[-1]))
expect_true(all(dfs0$p$undecided < d0$p$undecided))
expect_true(all(dfs1$p$undecided < d1$p$undecided))

df <- as.data.frame(dfs0$p)
df$cumExit <- cumsum(df$exit)
expect_true(all(rowSums(df[c("cumExit", "undecided", "cumFutStop")]) == 1))
df <- as.data.frame(dfs1$p)
df$cumExit <- cumsum(df$exit)
expect_true(all(rowSums(df[c("cumExit", "undecided", "cumFutStop")]) == 1))

# Compare 2-stage 'sequential' designs with LanDeMets software
# Reference values were calculated using Lan-DeMets software - see:
# https://www.biostat.wisc.edu/sites/default/files/lan-demets/WinLD.zip
# All results were obtained using Compute -> Probability, One-Sided and
# manually entered test boundaries (i.e. no alpha spending function).

# The calculated reference probabilities (lanDeMets) are found as the
# cumulative exit probability (rightmost column "Cum exit pr") in the
# result table of the software.

# Standard case
cumAlpha <- cumsum(seqDesign(crit=c(2, 2))$p$exit)
lanDeMets <- c(0.02275, 0.03799)
expect_equal(cumAlpha, lanDeMets, tol = 1e-4)

# Vary tau
tau <- c(.2, .5)
cumAlpha <- cumsum(seqDesign(crit=c(2, 2), tau=tau)$p$exit)
lanDeMets <- c(0.02275, 0.03945)
expect_equal(cumAlpha, lanDeMets, tol = 1e-4)
tau <- c(.2, .75)
cumAlpha <- cumsum(seqDesign(crit=c(2, 2), tau=tau)$p$exit)
lanDeMets <- c(0.02275, 0.04123)
expect_equal(cumAlpha, lanDeMets, tol = 1e-4)

# Incorporate drift (power calculations)
drift <- 1
cumAlpha <- cumsum(seqDesign(crit=c(2, 2), mu=drift)$p$exit)
lanDeMets <- c(0.09802, 0.19556)
expect_equal(cumAlpha, lanDeMets, tol = 1e-4)

drift <- 2
cumAlpha <- cumsum(seqDesign(crit=c(2, 2), mu=drift)$p$exit)
lanDeMets <- c(0.27901, 0.53892)
expect_equal(cumAlpha, lanDeMets, tol = 1e-4)

drift <- 3
cumAlpha <- cumsum(seqDesign(crit=c(2, 2), mu=drift,
                             tau=c(.3, .8))$p$exit)
lanDeMets <- c(0.36061, 0.77441)
expect_equal(cumAlpha, lanDeMets, tol = 1e-4)

exit_file("Internal gui functions - only tested interactively")

start_gui()
expect_equal(names(.env), c("name", "par", "par.last", "root"))

expect_true(inherits(.env[["root"]], "tkwin"))

params = lapply(as.list(.env[["par"]]), FUN = tclvalue)
last_params = as.list(.env[["par.last"]])
expect_true(identical(params, last_params))
onQuit()

exit_file("Internal functions only tested interactively")

t <- tktoplevel()
frame <- tkframe(t)
data <- as.data.frame(matrix(1:9, nrow = 3, ncol = 3))

tab <- create_table(frame, dims = dim(data), name = "test")
tkpack(tab)
tkpack(frame)

for (i in seq_len(nrow(data))) {
    for (j in seq_len(ncol(data))) {
        val <- data[i, j]
        set_cell_value(tab, i, j, val)
        entry <- get_cell_value(tab, i, j)
        expect_equal(as.character(val), entry)
    }
}

# Verify table-wise disable works as expected
tkconfigure(tab, state = "disabled", bg = "green")
for (i in seq_len(nrow(data))) {
    for (j in seq_len(ncol(data))) {
        val <- data[i, j]
        set_cell_value(tab, i, j, val + 10)
        entry <- get_cell_value(tab, i, j)
        expect_equal(as.character(val), entry)
    }
}

# Verify table-wise re-enable works as expected
tkconfigure(tab, state = "normal", bg = "green")
for (i in seq_len(nrow(data))) {
    for (j in seq_len(ncol(data))) {
        val <- data[i, j]
        set_cell_value(tab, i, j, val + 10)
        entry <- get_cell_value(tab, i, j)
        expect_equal(as.character(val + 10), entry)
    }
}


data2 <- as.data.frame(matrix(15:20, nrow = 2, ncol = 3))
tkconfigure(tab, rows = nrow(data2) + 1, cols = ncol(data2))

for (i in seq_len(nrow(data2))) {
    for (j in seq_len(ncol(data2))) {
        val <- data2[i, j]
        set_cell_value(tab, i, j, val)
        entry <- get_cell_value(tab, i, j)
        expect_equal(as.character(val), entry)
    }
}

tkdestroy(t)

exit_file("Internal gui functions - only tested interactively")

# create_combobox  TODO:


# create_numeric_entry TODO:


# create_radiobutton
root <- tcltk::tktoplevel()
dummy <- new.env()
dummy[["foo"]] <- tclVar("1")
rb1 <- create_radiobutton(root, "foo", value = 1, register = dummy)
rb2 <- create_radiobutton(root, "foo", value = 2, register = dummy)
tkgrid(rb1, rb2)

expect_equal(tclvalue(tcl(rb1, "state")), "selected")
expect_equal(tclvalue(tcl(rb2, "state")), "")
expect_equal(tclvalue(dummy[["foo"]]), "1")
tclvalue(dummy[["foo"]]) <- 2
expect_equal(tclvalue(tcl(rb1, "state")), "")
expect_equal(tclvalue(tcl(rb2, "state")), "selected")
tkdestroy(root)

---
title: "-1- Compute Bounds"
output:
  rmarkdown::html_vignette:
    toc: true
    toc_depth: 4
description: >
  This vignette shows how to use GroupSeq to compute group sequential designs
  under the null hypothesis, introduces all available options and discusses
  some nuances of certain design types.
vignette: >
  %\VignetteIndexEntry{-1- Compute Bounds}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r knitr-setup, include = FALSE}
library(knitr)
knitr::opts_chunk$set(
  comment = "#",
  prompt = F,
  tidy = FALSE,
  cache = FALSE,
  collapse = T,
  echo = FALSE,
  dpi = 300,
  fig.width = 5, fig.height = 5
)

old <- options(width = 100L, digits = 10)
```

The option -1- menu initially looks as follows.

```{r, out.width = "35%", echo = FALSE}
include_graphics("figures/task1-menu.png")
```

### Single stage

As a first example, let's hit the `CALCULATE` button, which should open a
new window with the following results.

```{r, out.width = "50%"}
include_graphics("figures/task1-1stage-result.png")
```

Since the number stages was set to $K = 1$, we just calculated one-sided
bounds for a simple 1-stage design, which is equivalent to

```{r, echo = TRUE}
alpha = 0.05
qnorm(1 - alpha)
```

### O'Brien-Fleming 3-stage design

To obtain a true group sequential design, we have to select $K > 1$ stages.
The number of stages is chosen at the top of the window.
Note that in GroupSeq this is called
`#Interim Times`, which means that the final analysis also is treated as an
'interim time'. Thus, for a 3-stage design, we select $K = 3$.

```{r, out.width = "25%"}
include_graphics("figures/task1-select-K3.png")
```
<br>

Hit `CALCULATE` to compute the 3-stage design.

```{r, out.width = "50%"}
include_graphics("figures/task1-3stage-result.png")
```

<br>

In the second to last column, you see how much alpha is spent at each stage,
while in the last column you see the cumulative alpha, which should sum up
to the overall significance level (here 5%).

Obviously, there are infinitely many ways to split the 5% over the three stages.
The default alpha spending strategy in GroupSeq is the O'Brien-Fleming type,
which is probably the most popular group sequential design in clinical trials.

As you see, the O'Brien-Fleming is very conservative at the early stages
of the study so that only 0.069% of alpha is spent at stage 1. The effect
therefore would have to be very large in order to exceed the critical
upper bound of 3.2 at stage 1 when 33% of the total sample will have been
collected.

To get a visual impression you can click the `Show Graph` button in the result
window which provides the following plot.

```{r, out.width = "50%"}
include_graphics("figures/task1-3stage-result-graph.png")
```

<br>
The advantage of this conservative strategy is that you still leave enough
alpha for the final analysis to reject `H0` for significant but moderate effects.

### Pocock 3-stage design

Another popular design, which actually had a significant positive impact on
the general popularity of group sequential designs in clinical research,
is the design by Pocock, which is constructed such the bounds are identical
at each stage. Let's select `(5) Exact Pocock Bounds` and hit `CONFIRM FUNCTION`.

```{r, out.width = "35%", echo = FALSE}
include_graphics("figures/task1-3stage-pocock.png")
```

<br>
When hitting the `CALCULATE` button, this time we get the following.

```{r, out.width = c("55%", "40%"), echo = FALSE,fig.show="hold"}
include_graphics("figures/task1-3stage-pocock-result.png")
include_graphics("figures/task1-3stage-pocock-result-graph.png")
```

<br>
The resulting upper bounds are set constant over all stages at
1.99. Obviously this design is more aggressive than the O'Brien-Fleming design
in trying to abort early as 0.023% of alpha is already spent at the first
stage (see second to last column in above figure).

While the critical bounds are constant over all stages, the spent alpha is not.
Rather it is decreasing with each stage. This is "caused" by
the sample size, which is increasing on later stages, so that, roughly speaking,
it gets less likely under `H0` to produce a type I error.

### O'Brien-Fleming vs Pocock

When comparing the final stage of both designs, the spent alpha in the
O'Brien-Fleming design (0.034%) is roughly three times higher than in
the Pocock design (0.011%), which means that if the study is not aborted at
one of the interim analysis, once you reach the final stage the effect needs to
be much higher in the Pocock design to reject `H0` at the final stage.

Beside the statistical power there are other aspects such as
the expected sample size that can be taken into
consideration when comparing designs which however goes beyond the scope
of this vignette. This is also true with respect to the other available
designs^[To be exact, these are alpha spending functions, which lead to
certain types of designs.],
and it is recommended to consult the literature to study the properties
of the different designs.

You may have also noted that among the available design functions there is
`(2) Pocock type`, which is is very similar to option `(5) Exact Pocock Bounds`.
The `(2) Pocock type` is based on the alpha spending approach,
which always produces monotonously decreasing bounds and therefore does
not yield exact Pocock bounds by
definition. Since the Pocock design is very popular, the option of exact Pocock
bounds, which are slightly harder to compute, was added to GroupSeq.


### Non-equidistant interim times

To adjust interim times, which by default are equally spaced, the
correspondin checkmark has to be deselected.
```{r, out.width = "35%", echo = FALSE}
include_graphics("figures/task1-3stage-pocock-custom-times.png")
```

<br>
The times are entered manually, for example, lets start a bit later with the
first interim look.

```{r, out.width = "35%", echo = FALSE}
include_graphics("figures/task1-3stage-pocock-custom-times-entered.png")
```

<br>
and `CALCULATE`.

```{r, out.width = "50%", echo = FALSE}
include_graphics("figures/task1-3stage-pocock-custom-times-result.png")
```

<br>
We see that this leads to slightly lower bounds, which seems about right as
this design is less aggressive to abort the study early.


### Two-Sided bounds

Last but not least, the designs can be calculated for the two-sided symmetric

```{r, out.width = "35%", echo = FALSE}
include_graphics("figures/task1-3stage-pocock-two-side.png")
```

<br>
as well as the two-sided asymmetric case.

```{r, out.width = "35%", echo = FALSE}
include_graphics("figures/task1-3stage-pocock-two-side-asym.png")
```

<br>
Naturally, the alpha is split up symmetrically, but can be customized if needed.
Also the alpha spending function has to be set separately for each side.
As an example, lets go with O'Brien-Fleming and Pocock again (don't forget to
hit the `CONFIRM FUNCTION` buttons).


```{r, out.width = c("55%", "40%"), echo = FALSE,fig.show="hold"}
include_graphics("figures/task1-3stage-pocock-two-side-asym-result.png")
include_graphics("figures/task1-3stage-pocock-two-side-asym-graph.png")
```

<br>
Looking at the stage-wise alpha spending, we literally end up with a mixture
of both designs as there is some alpha spend on the early stages but still
saved some for the last stage.

So this is mainly what can be done with GroupSeq to construct designs under `H0`.
Next lets see how to calculate probabilities under `H1` and specifically
to determine the effect size that is required to achieve a certain probability
(i.e. power) to detect an existing effect, which can be done via the second
menu option:
[-2- Compute Drift given Power and Bounds](https://rpahl.github.io/GroupSeq/articles/task-2-compute-drift.html)


```{r, include = FALSE}
options(old)
```

---
title: "-3- Compute Probabilities given Bounds and Drift"
output:
  rmarkdown::html_vignette:
    toc: true
    toc_depth: 4
description: >
  This vignette shows how to use GroupSeq to compute group sequential
  probabilities under both H0 or H1.
vignette: >
  %\VignetteIndexEntry{-3- Compute Probabilities given Bounds and Drift}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r knitr-setup, include = FALSE}
library(knitr)
knitr::opts_chunk$set(
  comment = "#",
  prompt = F,
  tidy = FALSE,
  cache = FALSE,
  collapse = T,
  echo = FALSE,
  dpi = 300,
  fig.width = 5, fig.height = 5
)

old <- options(width = 100L, digits = 10)
```


This vignette builds right on
[-2- Compute Drift given Power and Bounds](https://rpahl.github.io/GroupSeq/articles/task-2-compute-drift.html)
so if you haven't seen the vignette it is recommended to visit this one first.

Taking forward the example from the last vignette, we want three stages of
manual bounds and enter a drift of `3.3553`.

```{r, out.width = "35%", echo = FALSE}
include_graphics("figures/task3-example-manual-bounds.png")
```

which `CALCULATE`s to

```{r, out.width = "50%"}
include_graphics("figures/task3-example-manual-bounds-results.png")
```

yielding about 90% of cumulative exit probability, which corresponds to the
study power assuming a standardized effect size of 3.3553. To see the type
I error of this design, that is, the probability under H0, we simply set the
drift to zero.

```{r, out.width = "35%"}
include_graphics("figures/task3-example-manual-bounds-zero-drift.png")
```

Re`CALCULATE` gives

```{r, out.width = "50%"}
include_graphics("figures/task3-example-manual-bounds-zero-drift-results.png")
```

thereby resulting in a type I error of about 16.3%, which clearly exceeds the
typically allowed level of 5%. As such the design is not valid.

To get closer to 5% we now could start adjusting the bounds bit by bit.
For example, as the design already spends 15.8% of alpha at stage 1, lets
increase the first stage bound to two.

```{r, out.width = c("40%", "55%"), echo = FALSE, fig.show = "hold"}
include_graphics("figures/task3-example-manual-bounds-zero-drift-adjusted.png")
include_graphics("figures/task3-example-manual-bounds-zero-drift-adjusted-results.png")
```

The type I error drops to about 3.8% so now we are a bit too conservative and
could further adjust. If we set the last bound to 2 as well, we actually end
up with a classic Pocock design.

```{r, out.width = c("40%", "55%"), echo = FALSE, fig.show = "hold"}
include_graphics("figures/task3-manual-Pocock.png")
include_graphics("figures/task3-manual-Pocock-results.png")
```

Very close already and of course the easiest way to get a Pocock design with
exactly 5% alpha level is to abort manual bounds and revert back to using
the corresponding function.

```{r, out.width = c("40%", "55%"), echo = FALSE, fig.show = "hold"}
include_graphics("figures/task3-exact-Pocock.png")
include_graphics("figures/task3-exact-Pocock-results.png")
```

Last but not least lets calculate the power for this design, if the drift is 2,

```{r, out.width = c("40%", "55%"), echo = FALSE, fig.show = "hold"}
include_graphics("figures/task3-exact-Pocock-drift2.png")
include_graphics("figures/task3-exact-Pocock-drift2-results.png")
```

which apparently gives about 56.6%.

In the last vignette of this series we will see how to
[-4- Compute Confidence Interval](https://rpahl.github.io/GroupSeq/articles/task-4-compute-CI.html)s
at the final stage of a group sequential study.



```{r, include = FALSE}
options(old)
```

---
title: "-4- Compute Confidence Interval"
output:
  rmarkdown::html_vignette:
    toc: true
    toc_depth: 4
description: >
  This vignette shows how to use GroupSeq to compute confidence intervals
  at the final stage of a group sequential analysis.
vignette: >
  %\VignetteIndexEntry{-4- Compute Confidence Interval}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r knitr-setup, include = FALSE}
library(knitr)
knitr::opts_chunk$set(
  comment = "#",
  prompt = F,
  tidy = FALSE,
  cache = FALSE,
  collapse = T
)

old <- options(width = 100L, digits = 10)
```

Let's assume you have planned a two-sided 3-stage Pocock design with 80% power.

```{r, out.width = "35%", echo = FALSE}
include_graphics("figures/task4-two-sided-3-stage-Pocock-setup.png")
```

The resulting design requires a drift of about 3.

```{r, out.width = c("55%", "38%"), echo = FALSE,fig.show="hold"}
include_graphics("figures/task4-two-sided-3-stage-Pocock.png")
include_graphics("figures/task4-two-sided-3-stage-Pocock-graph.png")
```

During the study you perform the interim analysis as planned when about 67% of
all samples were collected and obtain a standardized effect size of 2.5, exceeding
the critical bound (2.2894) so that you can abort the study and reject H0.

To compute the confidence interval at this point, open option -4- of GroupSeq and
enter the values as shown below.

```{r, out.width = "45%", echo = FALSE}
include_graphics("figures/task4-CI-setup.png")
```

Hitting `CALCULATE` yields the following.

```{r, out.width = "50%", echo = FALSE}
include_graphics("figures/task4-CI-result.png")
```

So for this study, the resulting confidence interval of the standardized
effect is (0.30, 5.38).

Depending on the underlying data distribution and applied
test statistic this will be "back-calculated" to obtain the confidence interval
for the value of interest (e.g. mean difference for some normally distributed
data or difference in proportions of some binomially distributed data).


```{r, include = FALSE}
options(old)
```

---
title: "Introduction to GroupSeq"
output:
  rmarkdown::html_vignette:
    toc: true
    toc_depth: 4
description: >
  Start here if this is your first time using GroupSeq. This vignette
  gives a brief overview of what can be done with GroupSeq.
vignette: >
  %\VignetteIndexEntry{Introduction to GroupSeq}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r knitr-setup, include = FALSE}
library(knitr)
library("ggplot2")

knitr::opts_chunk$set(
  comment = "#",
  prompt = F,
  tidy = FALSE,
  cache = FALSE,
  collapse = T,
  echo = FALSE,
  dpi = 300
)

okabe_palette <- c('orange' = "#E69F00",
                   'sky blue' = "#56B4E9",
                   'bluish green' = "#009E73",
                   'yellow' = "#F0E442",
                   'blue' = "#0072B2",
                   'vermillion' = "#D55E00",
                   'reddish purple' = "#CC79A7")

old <- options(width = 100L, digits = 10)
```

Group sequential designs in essence allow to lower the sample size of clinical
or other studies. To be clear - if a group sequentially designed study is
conducted until the final analysis, that is, without aborting at one
of the interim looks, the required sample will be larger compared to a simple
single stage study, because you have to "pay" for the added interim
analyses to prevent
[alpha inflation](https://en.wikipedia.org/wiki/Multiple_comparisons_problem).

But, from time to time, especially if the underlying effect is strong
(e.g. you have a very potent medicine),
you will abort the study early and this on average
leads to lower sample sizes, or in other words, the expected sample size of
group sequential designs is lower than the sample size of comparable studies
with just one final analysis.

If you want to get an intuitive understanding on how probabilities of group
sequential designs are calculated, please see the vignette
[Understanding group sequential designs](https://rpahl.github.io/GroupSeq/articles/understanding-gs-designs.html).

The GroupSeq package can be used to perform basic calculations related
to group sequential designs. At this point, the functionality is mainly
provided via a graphical user interface. The interface was designed such that
each calculation can be opened in separate windows allowing to compute
and compare arbitrary many designs in parallel.

The following section gives a brief overview of all the available options
with links to further details.

### GroupSeq menu

Loading the library opens the main GroupSeq window.

```{r, eval = FALSE, echo = TRUE}
library("GroupSeq")
```

```{r, out.width = "35%", echo = FALSE}
include_graphics("figures/menu-after-load.png")
```

<br>

The menu lists four possible tasks. To select a task, you have to select a row
and hit the `Perform Selected Task` button.
Each task opens in a new window and it's also possible to open
multiple windows of the same task in parallel.
For a detailed description of the respective task follow one of the links below:

#### [-1- Compute Bounds](https://rpahl.github.io/GroupSeq/articles/task-1-compute-bounds-H0.html)

Use this to compute the boundaries of group sequential designs under the null
hypothesis (`H0`), that is, under a given significance level alpha (usually 5%).

```{r, out.width = "25%", echo = FALSE}
include_graphics("figures/task1-menu.png")
```

* Computes group sequential bounds under the null hypothesis for given overall
  significance level.
* Bounds can be one- or two-sided or completely asymmetric.
* User chooses number of stages and some alpha spending function.


#### [-2- Compute Drift given Power and Bounds](https://rpahl.github.io/GroupSeq/articles/task-2-compute-drift.html)

Use this to compute the target effect size of a group sequential design,
which maintains a certain power (e.g. power = 80%).

```{r, out.width = "25%", echo = FALSE}
include_graphics("figures/task2-menu.png")
```

* Computes drift (i.e. standardized effect size) required to achieve desired power
  of a given group sequential design.
* The group sequential design is defined via alpha spending functions or custom
  critical bounds.
* Bounds can be one- or two-sided or completely asymmetric.
* User chooses number of stages.


#### [-3- Compute Probabilities given Bounds and Drift](https://rpahl.github.io/GroupSeq/articles/task-3-compute-bounds-H1.html)

Use this to compute the power of a group sequential design.

```{r, out.width = "25%", echo = FALSE}
include_graphics("figures/task3-menu.png")
```

* Computes power that is achieved by a group sequential design given some drift
  (i.e. standardized effect size).
* The group sequential design is defined via alpha spending functions or custom
  critical bounds.
* Bounds can be one- or two-sided or completely asymmetric.
* User chooses number of stages.


#### [-4- Compute Confidence Interval](https://rpahl.github.io/GroupSeq/articles/task-4-compute-CI.html)

Use this to compute the confidence intervals for the target outcome
at the final analysis, which can be the last stage as planned or at an earlier
stage exceeding the critical bounds and therefore stopping early.

```{r, out.width = "25%", echo = FALSE}
include_graphics("figures/task4-menu.png")
```

* Computes confidence interval at final analysis stage for given expected effect size.
* The group sequential design is defined via alpha spending functions or custom
  critical bounds.
* Bounds can be one- or two-sided or completely asymmetric.
* User chooses number of stages and confidence level.


To close the application and, with it, all open windows, just close the main
window or hit the `QUIT GroupSeq` button.



```{r, include = FALSE}
options(old)
```

---
title: "Understanding group sequential designs"
output:
  rmarkdown::html_vignette:
    toc: true
    toc_depth: 4
description: >
  See this vignette if you want to understand how group sequential design
  probabilities are calculated and gain an intuitive understanding of the
  underlying methods.
vignette: >
  %\VignetteIndexEntry{Understanding group sequential designs}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r knitr-setup, include = FALSE}
library(knitr)
library("ggplot2")

knitr::opts_chunk$set(
  comment = "#",
  prompt = F,
  tidy = FALSE,
  cache = FALSE,
  collapse = T,
  echo = FALSE,
  dpi = 300,
  fig.width = 5, fig.height = 5
)

okabe_palette <- c('orange' = "#E69F00",
                   'sky blue' = "#56B4E9",
                   'bluish green' = "#009E73",
                   'yellow' = "#F0E442",
                   'blue' = "#0072B2",
                   'vermillion' = "#D55E00",
                   'reddish purple' = "#CC79A7")

old <- options(width = 100L, digits = 10)
```


While calculating probabilities of group sequential designs can be considered
somewhat complex, it may be less difficult than most people think. This vignette
provides a visual explanation of the underlying method to help forming
an intuitive understanding of this topic.
The author is convinced that gaining an intuitive understanding of these
calculations helps when applying and interpreting such designs in practice.

### One-sample study
Following the easy-to-hard principle, we start with conventional non-sequential
study designs and gradually progress to the group sequential case.

Consider you have a sample of data, let's call it `X1`.

```{r}
fill_colors = c(X1 = okabe_palette[["bluish green"]],
                X2 = okabe_palette[["vermillion"]],
                "X1+X2" = "#6B7E3A")

data  = data.frame(x = c(1:10, 1:10, 1:20),
                   y = c(rep(2, 10), rep(1.5, 10), rep(1.5, 20)),
                   Sample = c(rep("X1", 10), rep("X2", 10), rep("X1+X2", 20))
)
```


```{r, out.width = "35%", message = FALSE, fig.height = 1, fig.width = 2.5, fig.align = "center", fig.cap = "Schematic view of a study sample - each circle represents some measurement."}
dat = data[1:10, ]
ggplot(dat, aes(x = x, y = y)) +
    geom_point(size = 10, shape = 21, aes(fill = Sample)) +
    scale_fill_manual(values = fill_colors[1]) +
    lims(x = c(0.5, 10.5), y = c(2, 2)) +
    theme_void() +
    theme(legend.position = "bottom")

```
<br>
Usually some standardized test statistic is calculated and,
assuming standard normally distributed data, the density distribution under the
null hypothesis forms the well-known bell-shaped curve.

```{r, echo = FALSE, out.width = "65%", fig.cap = fig.cap, fig.height=3}
fig.cap = "Standard Normal Density with critial bounds marking 5% significance level."

blue = okabe_palette[["sky blue"]]
yellow = okabe_palette[["yellow"]]


crit = qnorm(1 - 0.025)
probLabel = paste0(pnorm(-crit)*100, "%")
x = seq(-3, 3, by = 0.01)

normalDensPlot =
    ggplot(data.frame(x = x), aes(x = x)) +
    stat_function(fun = dnorm, geom = "area", fill = blue, xlim = c(-4, -crit)) +
    stat_function(fun = dnorm, geom = "area", fill = yellow, xlim = c(-crit, crit)) +
    stat_function(fun = dnorm, geom = "area", fill = blue, xlim = c(crit, 4)) +
    stat_function(fun = dnorm, color = okabe_palette[["bluish green"]], size = 1.5) +
    geom_segment(x = 2.2, xend = 2.7, y = 0.02, yend = 0.07) +
    geom_segment(x = -2.2, xend = -2.7, y = 0.02, yend = 0.07) +
    annotate("text", label = probLabel, x = 2.9, y = 0.09, size = 3.5) +
    annotate("text", label = probLabel, x = -2.9, y = 0.09, size = 3.5) +
    lims(x = range(x)) +
    labs(x = expression(x[1]),
         y = expression(f(x[1]))) +
    theme_minimal() +
    theme(panel.grid.major = element_blank(),
          panel.grid.minor = element_blank(),
          axis.ticks.x = element_line())

normalDensPlot
```

<br>
If a two-sided test is planned with a significance level of $\alpha = 5\%$,
the critical bounds are set as visualized in the above figure.
In the days before computers these bounds had to be looked up in tables in some
book, but these days of course you just plug-in the numbers in your favorite
statistics program. In R its
```{r, echo = TRUE}
qnorm(0.025)
```

Now what do these bounds mean? Basically, if the null
hypothesis ($H_0$) was true, the probability of obtaining a test statistic at or
beyond these bounds is $2\cdot 0.025 = 0.05$, which therefore
limits the so-called type I error (rejecting $H_0$ although its true) at 5%.

Going forward the key thing to note here is that calculating this probability
basically means *calculating the (blue) area under the density curve* (see above
figure). Again, these days it's easy to derive the area using computer's
numerical integration.


### Combining two studies

Now lets consider another sample `X2` that was collected independently from `X1`.


```{r, out.width = "35%", message = FALSE, fig.height = 1.3, fig.width = 2.5, fig.align = "center"}
dat = data[1:20, ]
ggplot(dat, aes(x = x, y = y)) +
    geom_point(size = 10, shape = 21, aes(fill = Sample)) +
    scale_fill_manual(values = fill_colors[1:2]) +
    lims(x = c(0.5, 10.5), y = c(1.2, 2.2)) +
    theme_void() +
    theme(legend.position = "bottom")

```

<br>
If we construct a distribution similar to the one above, we have the following.

```{r, fig.width = 8, fig.height = 3, out.width = "85%"}
normalDensPlotX2 = normalDensPlot +
    labs(x = expression(x[2]), y = expression(f(x[2]))) +
    stat_function(fun = dnorm, color = okabe_palette[["vermillion"]], size = 1.5)
gridExtra::grid.arrange(normalDensPlot, normalDensPlotX2, nrow = 1)
```

<br>
A statistical test on both samples now would control the type I error for each of
these studies at the 5% level, but, of course, things are more complicated
if you consider both samples at the same time, because now you have two chances
of conducting the type I error.

So if we assume our samples `X1` and `X2` were sampled from
the same population and we are interested to test the same outcome,
to control the *overall* type I error still at 5% we need to down-adjust alpha.
The simplest and most common approach is to use the Bonferroni correction,
which means we are allowed to spend $\alpha_{Bonf} = \alpha/2 = 0.025$.
The corresponding adjusted critical bound is
```{r, echo = TRUE}
qnorm(0.025/2)
```
and we have

```{r, echo = FALSE, out.width = "65%", fig.cap = fig.cap, fig.height=3}
fig.cap = "Standard Normal Density with critial bounds marking 5% significance level."

blue = okabe_palette[["sky blue"]]
yellow = okabe_palette[["yellow"]]

crit = qnorm(1 - 0.025/2)
probLabel = paste0(pnorm(-crit)*100, "%")
x = seq(-3, 3, by = 0.01)

normalDensPlotAdj =
    ggplot(data.frame(x = x), aes(x = x)) +
    stat_function(fun = dnorm, geom = "area", fill = blue, xlim = c(-4, -crit)) +
    stat_function(fun = dnorm, geom = "area", fill = yellow, xlim = c(-crit, crit)) +
    stat_function(fun = dnorm, geom = "area", fill = blue, xlim = c(crit, 4)) +
    stat_function(fun = dnorm, color = okabe_palette[["bluish green"]], size = 1.2) +
    geom_segment(x = 2.2+.2, xend = 2.7+.2, y = 0.02, yend = 0.07) +
    geom_segment(x = -2.2-.2, xend = -2.7-.2, y = 0.02, yend = 0.07) +
    annotate("text", label = probLabel, x = 2.9, y = 0.09, size = 3.5) +
    annotate("text", label = probLabel, x = -2.9, y = 0.09, size = 3.5) +
    lims(x = range(x)) +
    labs(x = expression(x[1]),
         y = expression(f(x[1]))) +
    theme_minimal() +
    theme(panel.grid.major = element_blank(),
          panel.grid.minor = element_blank(),
          axis.ticks.x = element_line())
```

```{r, fig.width = 8, fig.height = 3, out.width = "85%"}
normalDensPlotX2Adj = normalDensPlotAdj +
    labs(x = expression(x[2]), y = expression(f(x[2]))) +
    stat_function(fun = dnorm, color = okabe_palette[["vermillion"]], size = 1.5)
gridExtra::grid.arrange(normalDensPlotAdj, normalDensPlotX2Adj, nrow = 1)
```


```{r}
alpha = 0.05
alpha.Bonf = alpha / 2
alpha.Sidak = 1 - (1-alpha)^(1/2)

crit.Bonf = -rep(qnorm(alpha.Bonf / 2), 2)
crit.Sidak = -rep(qnorm(alpha.Sidak / 2), 2)
```
So if we calculate the overall type I error probability, we sum up all the areas
and get $p = 1.25\% + 1.25\%+ 1.25\% + 1.25\% = 5\%$.
So we are good, are we? Well, the devil is in the details.

Remember, the goal was to make
sure that we don't conduct a type I error. The probability to conduct *no*
type I at either `X1` or `X2` is $p = 1-\alpha_{Bonf} = 1-0.025 = 0.975$.

From this it
follows that the probability to conduct no error at both `X1` and `X2` is
$(1-\alpha_{Bonf})^2 = 0.950625$.

Now we can calculate the complementary probability
of conducting *at least one* type I error as
$p = 1 - (1-\alpha_{Bonf})^2 = 0.049375 = 4.9\%$. Wait, why is it not 5%?
Well, the reason
is that we don't care if one or both studies produce a type I error, as one
error is already enough for the overall setup to fail. As a result, the
Bonferroni correction is not optimal, as it "wastes" 0.1% of alpha.

<br>
Of course, this is well-known and a precise alpha adjustment can be derived via
the so-called
[Sidak correction](https://en.wikipedia.org/wiki/%C5%A0id%C3%A1k_correction):
$\alpha_{Sidak} = 1 - (1-\alpha)^{1/2} = 0.02532057 > \alpha_{Bonf}$.

Plugging this into the above formula, we get
$p = 1 - (1-\alpha_{Sidak})^2 = 0.05 = 5\%$.
If you are interested, you can find the
derivation of [Sidak's](https://en.wikipedia.org/wiki/%C5%A0id%C3%A1k_correction) formula
under the link, but I have promised you to provide intuitive explanations,
so let's move to the key concept that will also help to understand group
sequential probabilities.


### Combining two distributions

If we want to combine both studies, it makes sense to combine the two
density distributions into a two-dimensional (aka bivariate) normal distribution,
which then looks like this.

```{r prepare-2D-normal-density-plot, echo = FALSE, include = FALSE}
mu = 0
Mean = c(mu, mu)
covariance = 0
Sigma0 = matrix(c(1, rep(covariance, 2), 1), 2)


width = 6.6
binwidth = 0.2
x1 = x2 = seq(from = mu - width/2, to = mu + width/2, by = binwidth)
grid = expand.grid(x1, x2)

z = mvtnorm::dmvnorm(grid, mean = Mean, sigma = Sigma0)
zmat = matrix(z, ncol = length(x1))

grid.col = expand.grid(x1[-1] - binwidth/2, x2[-1] - binwidth/2)
gc1 = grid.col[, 1]
gc2 = grid.col[, 2]

crit = crit.Sidak
get_color = Vectorize(function(x1, x2) {
    if (x1 < -crit[1] || x1 > crit[1] || x2 < -crit[2] || x2 > crit[2])
        blue else yellow
})

plot_normal_dens_2d = function(zmat, ...) {
    persp(x1, x2, zmat,
          expand = 0.5,
          lphi = 0,
          xlab = "x1",
          ylab = "x2\n",
          zlab = "f(x1, x2)",
          shade = 0.2,
          ticktype = "detailed",
          ...)
}
```


```{r, out.width = "55%"}
op = par(mar = c(0, 2, 0, 0))
plot_normal_dens_2d(zmat, phi = 45, col = get_color(gc1, gc2))
par(op)
```

Remember that determining the probability of distributions is all about
doing numerical integration under the curve, that is, the overall type I error
now is derived by computing the volume under the blue area. To do this, we
are using the
[mvtnorm](https://CRAN.R-project.org/package=mvtnorm) package.^[To keep matters simple,
we just discuss the results, but if you want to see the actual R commands,
just inspect the source code of this vignette.]


```{r, include = FALSE}
crit.Bonf = -rep(qnorm(alpha.Bonf / 2), 2)
crit.Sidak = -rep(qnorm(alpha.Sidak / 2), 2)

crit = crit.Bonf
crit = crit.Sidak

calc2Dprob = function(crit, sigma) {
    calc_prob = function(lower, upper) {
        as.numeric(mvtnorm::pmvnorm(lower = lower, upper = upper, sigma = sigma))
    }

    left_stripe = calc_prob(lower = c(-Inf, -Inf), upper = c(-crit[1], Inf))
    lower_rectangle = calc_prob(lower = c(-crit[1], -Inf), upper = c(crit[1], -crit[2]))
    2 * left_stripe + 2 * lower_rectangle # return two-sided prob
}

p.edge = as.numeric(mvtnorm::pmvnorm(lower = c(-Inf, -Inf),
                                     upper = c(-crit[1], -crit[2]),
                                     sigma = Sigma0))


p2D.Bonf = calc2Dprob(crit.Bonf, sigma = Sigma0)
p2D.Sidak = calc2Dprob(crit.Sidak, sigma = Sigma0)
```

If we plug in the Bonferroni bounds (`r round(crit.Bonf[1], 4)`) in each dimension and
calculate the probability for the blue
area, we get p = `r p2D.Bonf` while the Sidak bounds (`r round(crit.Sidak[1], 4)`)
yield p = `r p2D.Sidak`,
which matches our results from above.

However, we now also have a graphical intuitive interpretation to explain the
results. For this, have a look at the next graph.

```{r, out.width = "55%"}
orange = okabe_palette[["orange"]]
crit = crit.Sidak
get_color_edges = Vectorize(function(x1, x2) {
    # Make edges grey
    if (x1 < -crit[1] && x2 < -crit[2] ||
        x1 < -crit[1] && x2 >  crit[2] ||
        x1 >  crit[1] && x2 < -crit[2] ||
        x1 >  crit[1] && x2 >  crit[2])
        return("grey")

    if (x1 < -crit[1] || x1 > crit[1] || x2 < -crit[2] || x2 > crit[2])
        blue else yellow
})

op = par(mar = c(0, 2, 0, 0))
plot_normal_dens_2d(zmat, phi = 45, col = get_color_edges(gc1, gc2))
par(op)
```


The grey areas basically mark those scenarios where the type I errors of both
samples fall together.
The intuitive explanation now goes like this: when calculating the overall
probability using the two-dimensional normal distribution,
the grey areas are only counted once whereas in the one-dimensional Bonferroni
case you count them twice. To see this, we can calculate the probability
for one of these edges,
which is p = 0.00016, and if we subtract them from the overall alpha
we get $p = 0.05 - 4\cdot 0.00016 = 0.04936$, which corresponds to the overall
probability under Bonferroni correction as we saw above.

So when using the two-dimensional normal distribution, we naturally derive at the
optimal solution for the alpha adjustment. The same is true for group sequential
designs, which further optimize the calculation by taking into account
the dependency of the staged samples.


### Group sequential study

In a (group) sequential study design, samples are analyzed in a sequence
where at each stage all the data from earlier stages are combined with the
data of the current stage.

For example, in the first stage we collect a sample `X1` and in a second
stage we combine the sample `X1` with a new sample `X2`.

```{r, out.width = "35%", message = FALSE, fig.height = 1.3, fig.width = 2.5, fig.align = "center"}
dat = data[1:20, ]
dat[11:20, "x"] = 11:20
dat = rbind(data.frame(x = 1:10, y = 1.5, Sample = "X1"), dat)
ggplot(dat, aes(x = x, y = y)) +
    geom_point(size = 10, shape = 21, aes(fill = Sample)) +
    scale_fill_manual(values = fill_colors[1:2]) +
    lims(x = c(0.5, 20.5), y = c(1.2, 2.2)) +
    theme_void() +
    theme(legend.position = "bottom")

```

The crucial difference when combining the samples in this way is that now they
are inherently dependent, that is, the statistic of sample `X1 + X2` will be
correlated to the that of sample `X1`.

With this in mind, the graphical presentation below is more precise to
visualize the data sample setup.

```{r, out.width = "35%", message = FALSE, fig.height = 1.3, fig.width = 2.5, fig.align = "center", fig.cap = "Schematic view of group sequential two-stage study."}
dat = data[c(1:10, 21:40), ]

ggplot(dat, aes(x = x, y = y)) +
    geom_point(size = 10, shape = 21, aes(fill = Sample)) +
    scale_fill_manual(values = fill_colors[c(1, 3)]) +
    lims(x = c(0.5, 20.5), y = c(1.2, 2.2)) +
    theme_void() +
    theme(legend.position = "bottom")

```

The naive approach for the alpha adjustment again would be to treat both
density distributions as independent and apply the Bonferroni correction.

```{r, fig.width = 8, fig.height = 3, out.width = "85%", fig.cap = "Normal densities for stage 1 and 2 with Bonferroni bounds."}
normalDensPlotX2Adj = normalDensPlotAdj +
    labs(x = expression(x[2]), y = expression(f(x[2]))) +
    stat_function(fun = dnorm, color = fill_colors[3], size = 1.5)
gridExtra::grid.arrange(normalDensPlotAdj, normalDensPlotX2Adj, nrow = 1)
```

Since this completely ignores the correlation, we expect that even more alpha
is wasted. To see this let's now again use the two-dimensional distribution.

```{r}
mu = 0
Mean = c(mu, mu)
covariance = sqrt(0.5)
Sigma = matrix(c(1, rep(covariance, 2), 1), 2)

z = mvtnorm::dmvnorm(grid, mean = Mean, sigma = Sigma)
zmat = matrix(z, ncol = length(x1))
```


```{r, fig.show="hold", out.width = "30%", fig.cap = "Bivariate normal density of two-stage design viewed from different angles."}
op = par(mar = rep(.1, 4))
plot_normal_dens_2d(zmat, phi = 40, col = get_color(gc1, gc2), box = FALSE)
plot_normal_dens_2d(zmat, phi = 65, col = get_color(gc1, gc2), box = FALSE)
plot_normal_dens_2d(zmat, phi = 90, col = get_color(gc1, gc2), box = FALSE)
par(op)
```

We again omit the details on how to derive the distribution, but as you can see,
the correlation leads to a flattened bell curve, which in the independent case
before was perfectly symmetrical. Also the amount of correlation is proportional
to the data overlap of the stages. For example, if the first stage used 5 instead
of the 10 data points, the stages would be less correlated and therefore the
bell curve less flattened.

```{r}
p2D.Bonf = calc2Dprob(crit.Bonf, sigma = Sigma)
```

Based on this distribution, the Bonferroni bounds (`r round(crit.Bonf[1], 2)`)
now yield p = `r round(p2D.Bonf, 3)` so that for this group sequential study
`r round((0.05 - p2D.Bonf)*100, 1)`% of alpha would be "wasted".

Intuitively, the flattened curve has pulled some mass into the middle leaving
less volume under the blue area.

#### Pocock design

The idea of group sequential designs obviously is to come up with bounds that
lead to overall 5% type I error. Let's start with so-called Pocock bounds,
which means we want equal bounds at all stages. Using the GroupSeq package,
these can be derived as follows.

```{r, out.width = "40%", echo = FALSE}
include_graphics("figures/two-stage-Pocock-bounds.png")
```

```{r, out.width = "70%", echo = FALSE}
include_graphics("figures/two-stage-Pocock-bounds-result.png")
```


```{r}
crit.Pocock = rep(2.1783, 2)
p2D.Pocock = calc2Dprob(crit.Pocock, sigma = Sigma)
```

So the Pocock bounds are `r crit.Pocock[1]` and thus as expected lower than the
Bonferroni bounds. The last entry in the 'cumulative alpha' column shows
the overall alpha, which is close to 5%.^[In fact, it is
closer to 5% (`r p2D.Pocock`) than shown in the GroupSeq application,
which stems from the
fact that the GroupSeq legacy version uses a different more rudimentary
numerical integration algorithm.]

Inspecting the probabilities stage by stage, 2.93% of alpha is spent at the first
and 2.04% at the second stage, respectively. That is, although the nominal bounds
are identical at both stages, due to the asymmetric shape of the two-dimensional
distribution, the resulting probabilities are different.

The graphical presentation of group sequential designs normally is done with
a graph showing at the x-axis the "Information Rate", which marks the relative
sample size of the respective stages, and the nominal bounds at the y-axis.
The above Pocock design thus looks something like this.

```{r, echo = FALSE, out.width = "50%", fig.cap = "Group sequential 2-stage Pocock design with one interim look at half of the total samples."}
n = 100
tt = c(.5, 1)
crit = crit.Pocock
x = seq(0.2, 1.0, length = n)

upperLine = data.frame(x = x, y = crit[1])
lowerLine = data.frame(x = x, y = -crit[1])

upperArea = data.frame(x = x, ymin = upperLine$y, ymax = 3, y = 3)
innerArea = data.frame(x = x, ymin = lowerLine$y, ymax = upperLine$y, y = 0)
lowerArea = data.frame(x = x, ymin = -3, ymax = lowerLine$y, y = -3)

p = ggplot(mapping = aes(x = x, y = y)) +

    geom_ribbon(data = upperArea, aes(x = x, ymin = ymin, ymax = ymax, y = y), fill = blue) +
    geom_ribbon(data = innerArea, aes(x = x, ymin = ymin, ymax = ymax, y = y), fill = yellow) +
    geom_ribbon(data = lowerArea, aes(x = x, ymin = ymin, ymax = ymax, y = y), fill = blue) +

    geom_line(data = upperLine) +
    geom_line(data = lowerLine) +

    geom_point(data = data.frame(x = tt, y =  crit), size = 5, shape = 21, fill = fill_colors[c(1, 3)]) +
    geom_point(data = data.frame(x = tt, y = -crit), size = 5, shape = 21, fill = fill_colors[c(1, 3)]) +

    theme_minimal() +
    labs(x = "Information Rate", y = "Critical Value") +
    lims(y = c(-3, 3)) +
    theme(panel.grid.major = element_blank(),
          panel.grid.minor = element_blank(),
          axis.ticks.x = element_line())

p
```

#### O'Brien-Fleming design

Probably the most popular group sequential design is the O'Brien-Fleming design.
For our two-stage scenario with half of the sample used in each stage,
it looks like this.

```{r, echo = FALSE, out.width = "50%", fig.cap = "Group sequential 2-stage O'Brien-Fleming design with one interim look at 0.5."}

asOBF <- function(t, alpha = 0.05, side = 2) {
  2 * (1 - stats::pnorm((stats::qnorm(1 - (alpha / side)/2)) / sqrt(t)))
}

n = 100
tt = c(.5, 1)

crit.OBF = -qnorm(asOBF(tt))
crit = crit.OBF
x = seq(0.2, 1.0, length = n)

upperLine = data.frame(x = x, y = -qnorm(asOBF(x)))
lowerLine = data.frame(x = x, y = qnorm(asOBF(x)))

upperArea = data.frame(x = x, ymin = upperLine$y, ymax = 6, y = 3)
innerArea = data.frame(x = x, ymin = lowerLine$y, ymax = upperLine$y, y = 0)
lowerArea = data.frame(x = x, ymin = -6, ymax = lowerLine$y, y = -3)

p = ggplot(mapping = aes(x = x, y = y)) +

    geom_ribbon(data = upperArea, aes(x = x, ymin = ymin, ymax = ymax, y = y), fill = blue) +
    geom_ribbon(data = innerArea, aes(x = x, ymin = ymin, ymax = ymax, y = y), fill = yellow) +
    geom_ribbon(data = lowerArea, aes(x = x, ymin = ymin, ymax = ymax, y = y), fill = blue) +

    geom_line(data = upperLine) +
    geom_line(data = lowerLine) +

    geom_point(data = data.frame(x = tt, y =  crit), size = 5, shape = 21, fill = fill_colors[c(1, 3)]) +
    geom_point(data = data.frame(x = tt, y = -crit), size = 5, shape = 21, fill = fill_colors[c(1, 3)]) +

    theme_minimal() +
    labs(x = "Information Rate", y = "Critical Value") +
    lims(y = c(-6, 6)) +
    theme(panel.grid.major = element_blank(),
          panel.grid.minor = element_blank(),
          axis.ticks.x = element_line())

p

```

The numbers are outlined below.

```{r, out.width = "70%", echo = FALSE}
include_graphics("figures/two-stage-OBF-bounds-result.png")
```

Clearly the critical bounds at stage one are very conservative so that
only 0.3% of alpha is spent there. With spending 4.7% of alpha at the last
stage this O'Brien-Fleming design in fact is not
much different to a standard single stage study, which spends all the 5% on the
full sample. Basically, the first stage is kind of a shot
in the dark to allow catching really big effects.

In contrast, the Pocock design appears to be more "aggressive" trying harder to
terminate the study early. Of course, the drawback of the Pocock strategy is
that if the study cannot be terminated after the first stage, it then only
has about 2% of alpha left for the final stage.

To apply the O'Brien-Fleming design more aggressively, one could plan the first
stage analysis at a later time point. For example, having the first interim
analysis after 70% of the samples already means that about 1.5% of alpha are
spent at stage 1.


#### Design comparisons

To strengthen our intuitive understanding, let's compare the Pocock and
O'Brien-Fleming design in the two-dimensional density view.

```{r, fig.show="hold", out.width = "45%", fig.cap = "Bivariate normal density with critical bounds of Pocock (left) and O'Brien-Fleming design (right) both with interim analysis after 50% of the sample."}
op = par(mar = rep(1.5, 4))
crit = crit.Pocock
plot_normal_dens_2d(zmat, phi = 80, col = get_color(gc1, gc2))
crit = crit.OBF
plot_normal_dens_2d(zmat, phi = 80, col = get_color(gc1, gc2))
par(op)
```

The figure below shows how the time point of the stage 1 analysis affects the
correlation of the stages and with that shapes the design probabilities.

```{r, fig.show="hold", out.width = "30%", fig.cap = "Bivariate normal density of two-stage O'Brien-Fleming design with first stage after 50% (left), 70% (middle) and 90% (right) of all samples."}

crit = crit.OBF
mu = 0
Mean = c(mu, mu)

Sigma = matrix(c(1, rep(sqrt(0.5), 2), 1), 2)
z = mvtnorm::dmvnorm(grid, mean = Mean, sigma = Sigma)
zmat0.5 = matrix(z, ncol = length(x1))

Sigma = matrix(c(1, rep(sqrt(0.7), 2), 1), 2)
z = mvtnorm::dmvnorm(grid, mean = Mean, sigma = Sigma)
zmat0.7 = matrix(z, ncol = length(x1))

Sigma = matrix(c(1, rep(sqrt(0.9), 2), 1), 2)
z = mvtnorm::dmvnorm(grid, mean = Mean, sigma = Sigma)
zmat0.9 = matrix(z, ncol = length(x1))


op = par(mar = rep(.1, 4))
plot_normal_dens_2d(zmat0.5, phi = 90, col = get_color(gc1, gc2), box = FALSE)
plot_normal_dens_2d(zmat0.7, phi = 90, col = get_color(gc1, gc2), box = FALSE)
plot_normal_dens_2d(zmat0.9, phi = 90, col = get_color(gc1, gc2), box = FALSE)
par(op)
```



```{r, include = FALSE}
options(old)
```

---
title: "-2- Compute Drift given Power and Bounds"
output:
  rmarkdown::html_vignette:
    toc: true
    toc_depth: 4
description: >
  This vignette shows how to use GroupSeq to compute group sequential designs
  with a certain power and how to interpret the results.
vignette: >
  %\VignetteIndexEntry{-2- Compute Drift given Power and Bounds}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r knitr-setup, include = FALSE}
library(knitr)
knitr::opts_chunk$set(
  comment = "#",
  prompt = F,
  tidy = FALSE,
  cache = FALSE,
  collapse = T,
  echo = FALSE,
  dpi = 300,
  fig.width = 5, fig.height = 5
)

old <- options(width = 100L, digits = 10)
```

If you haven't seen the vignette
[-1- Compute Bounds](https://rpahl.github.io/GroupSeq/articles/task-1-compute-bounds-H0.html),
it is recommended to visit this one first.

The option -2- menu initially looks as follows.

```{r, out.width = "35%", echo = FALSE}
include_graphics("figures/task2-menu.png")
```

### O'Brien-Fleming 3-stage design

<br>
For a start lets set `K=3` stages and `CALCULATE`.

```{r, out.width = c("55%", "40%"), echo = FALSE,fig.show="hold"}
include_graphics("figures/task2-3stage-OBF-result.png")
include_graphics("figures/task2-3stage-OBF-graph.png")
```

<br>
The design maintains the power of 80%. The second to last column
provides the `Exit Probability` for each stage. As is typical for
O'Brien-Fleming designs, the probability to abort the study
at the first interim look is very low (here 4%)
even under `H1`. Then on the second stage, it's 42% and cumulative
almost a 50% chance of having the study aborted by then and finally in one
third of the cases the effect is detected at the last stage while in the
remaining 20% of cases `H0` will be accepted and the effect stays undetected.
These probabilities are all valid if the true drift (i.e. true standardized
effect size) is 2.51.

### Pocock 3-stage design

Next lets see the required drift if we use a Pocock design.

```{r, out.width = "50%"}
include_graphics("figures/task2-3stage-Pocock-result.png")
```

Apparently, to achieve a power of 80%, this design requires an effect of 2.71,
which is 8% higher than that of the O'Brien-Fleming designs.
Comparing the power of both designs for a specific drift, is discussed in
[-3- Compute Probabilities given Bounds and Drift](https://rpahl.github.io/GroupSeq/articles/task-3-compute-bounds-H1.html).

With the Pocock design on the other hand you will be able to abort the study
at the first interim look in about 33% of the cases, so if you are optimistic
about your expected effect, the Pocock design might be the better choice as
it will result in lower required samples on average and thereby
a faster study conclusion.

To change the desired power, just edit the value in the input window.

```{r, out.width = "35%"}
include_graphics("figures/task2-set-power.png")
```

<br>
If we re-`CALCULATE`, we get

```{r, out.width = "50%"}
include_graphics("figures/task2-3stage-Pocock-result-power90.png")
```

<br>
As expected the required drift has increased to now 3.16, but there is also
something interesting to the resulting exit probabilities as basically the
10% increase in power was "added" to the first interim look, which now has a
probability of 43% to succeed. Also the exit probability at the final stage
even has been decreased slightly.

First of all, this is good news, of course, because it means that it has become
less likely that the full sample is required to come to a conclusion.
Intuitively, this also makes sense, because a stronger effect indicated by
the higher drift (on average) will be detected earlier than a weaker effect.

### Manual bounds

In order to enable the computation of drift for arbitrary designs, you can
enter bounds manually.

```{r, out.width = "35%", echo = FALSE}
include_graphics("figures/task2-set-manual-bounds.png")
```

<br>
Hitting `CALCULATE` for the default bounds 1, 2, 3, we get

```{r, out.width = "50%"}
include_graphics("figures/task2-3stage-Pocock-result-manual-bounds.png")
```

<br>
This design maintains the specified power, if the drift was
3.355, but it does not maintain the 5% alpha level under
`H0` (drift = 0).

To see this, check out the next vignette
[-3- Compute Probabilities given Bounds and Drift](https://rpahl.github.io/GroupSeq/articles/task-3-compute-bounds-H1.html)



```{r, include = FALSE}
options(old)
```
